#import <CoreFoundation/CoreFoundation.h>
#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#include <stdio.h>
#include <string.h>
#include <dlfcn.h>
#include <stdio.h>
#include <unistd.h>

//@class UIApplication;
@class UIImage;
@class UIImageView;
@class UIButton;
@class UILabel;
@class UIColor;
@class UIFont;

typedef NSUInteger UIControlState;
#import <UIKit/UISlider.h>

#define UIControlStateNormal 0
#define UIControlEventTouchUpInside (1 << 6)
#define UIControlEventValueChanged  (1 << 12)
#define UIControlEventTouchDownRepeat (1 <<  1)
#define TEXT_LENGTH 20480

@interface NotesView : UIView
{
}

- (NotesView*) initWindow;
- (void) transitionOut;
- (void) transitionIn;
- (void) CloseButtonPressed; 
- (void) endTimer:(NSTimer *)timer;
- (UIWindow*) getAppWindow;
- (void) showKeyboard:(BOOL)show;
- (void)textViewDidEndEditing:(UITextView *)textView;
@end

@implementation NotesView

//************************************************************************************************************
// initWindow - Initializes the brightness view window.
//************************************************************************************************************
- (NotesView*) initWindow
{
	self = [super initWithFrame:CGRectMake(-274.0f, 40.0f, 274.0f, 171.0f)];
	NSString* CurrentTheme;
	UIWindow* Window = [self getAppWindow];
	if([Window respondsToSelector:@selector(getCurrentTheme)])
	{
		CurrentTheme = [NSString stringWithString:[Window getCurrentTheme]];
	}
	else
	{
		CurrentTheme = [NSString stringWithString:@"Default"];
	}
	
	// Setup the background image.
	UIImageView* Image = [[UIImageView alloc] initWithFrame: CGRectMake(0.0f, 0.0f, 274.0f, 171.0f)];
	Image.image = [UIImage imageWithContentsOfFile:[NSString stringWithFormat:@"/var/mobile/Library/SBSettings/Themes/%@/SliderFrame3Row.png", CurrentTheme]];
	[self addSubview: Image];
	[Image release];
	
	UITextView* TextView = [[UITextView alloc] initWithFrame:CGRectMake(10.0f, 10.0f, 255.0f, 151.0f)];
	[TextView setDelegate: self];
	
	FILE* fp = fopen("/var/mobile/Library/SBSettings/note.txt", "r");
	char NotesText[TEXT_LENGTH];
	memset(NotesText, 0, TEXT_LENGTH);
	NotesText[0] = 0;
	if(fp != NULL)
	{
		fread(NotesText, TEXT_LENGTH-1, 1, fp);
		fclose(fp);
	}
	if(strlen(NotesText) > 0)
	{
		TextView.text = [NSString stringWithUTF8String:NotesText];
	}
	[self addSubview: TextView];
	[TextView release];
	
	// Setup the close button
	UIButton* CloseButtonBigger = [[UIButton alloc] initWithFrame:CGRectMake(234.0f, 0.0f, 40.0f, 40.0f)];
	[CloseButtonBigger addTarget:self action:@selector(CloseButtonPressed) forControlEvents:UIControlEventTouchUpInside];
	[self addSubview: CloseButtonBigger];
	[CloseButtonBigger release];

	UIButton* CloseButton = [[UIButton alloc] initWithFrame:CGRectMake(244.0f, 5.0f, 25.0f, 25.0f)];
	[CloseButton setShowsTouchWhenHighlighted: YES];
	[CloseButton setBackgroundImage:[UIImage imageWithContentsOfFile:[NSString stringWithFormat:@"/var/mobile/Library/SBSettings/Themes/%@/Close.png", CurrentTheme]] forState:UIControlStateNormal];
	[CloseButton addTarget:self action:@selector(CloseButtonPressed) forControlEvents:UIControlEventTouchUpInside];
	[self addSubview: CloseButton];
	[CloseButton release];
	
	return self;
}

//************************************************************************************************************
// textViewShouldBeginEditing - when text box is clicked into.
//************************************************************************************************************
- (BOOL)textViewShouldBeginEditing:(UITextView *)textView
{
	NSLog(@"should begin editing\n");
	[self showKeyboard: YES];
	return YES;
}

//************************************************************************************************************
// showKeyboard - enables / disables the keyboard.
//************************************************************************************************************
- (void) showKeyboard:(BOOL)show 
{
	NSLog(@"Showing keyboard %d", show);
	UIKeyboard *key = [UIKeyboard automaticKeyboard];
	if (!key) 
	{
		return;
	}
	if (show) 
	{
		[key orderInWithAnimation:YES];
	} 
	else 
	{
		[key orderOutWithAnimation:YES];
	}
}

//************************************************************************************************************
// scrollViewDidScroll - The scroll control delegate - this is where the brightness is actually changed..
//************************************************************************************************************
- (void)textViewDidEndEditing:(UITextView *)textView
{
	char Temp[TEXT_LENGTH];
	memset(Temp, 0, TEXT_LENGTH);
	
	NSLog(@"Did end editing\n");
	FILE* fp = fopen("/var/mobile/Library/SBSettings/note.txt", "w");
	if(fp != NULL)
	{
		NSString* Text = textView.text;
		if([Text length] > 0)
		{
			strncpy(Temp, [Text UTF8String], ([Text length] < TEXT_LENGTH ? [Text length] : TEXT_LENGTH));
			fwrite(Temp, strlen(Temp), 1, fp);
		}
		fclose(fp);
	}
	[self showKeyboard:NO];
}

//************************************************************************************************************
// CloseButtonPressed: When the close button pressed. Closes up the window.
//************************************************************************************************************
- (void) CloseButtonPressed 
{
	[self transitionOut];
}

//************************************************************************************************************
// transitionOut - transitions the window view out.
//************************************************************************************************************
- (void) transitionOut
{
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.5];
	CGAffineTransform transformView	= CGAffineTransformMakeTranslation(-297.0f, 0.0f);
	[self setTransform: transformView];
	[UIView commitAnimations];

	[NSTimer scheduledTimerWithTimeInterval:0.9 target:self selector:@selector(endTimer:) userInfo:nil repeats:NO];
}

//************************************************************************************************************
// endTimer: Timer callback to remove the rest of the controls after animation completes.
//************************************************************************************************************
- (void) endTimer:(NSTimer *)timer 
{
	[self removeFromSuperview];
}

//************************************************************************************************************
// getAppWindow - attempts to retrieve the app window.
//************************************************************************************************************
- (UIWindow*) getAppWindow
{
	UIWindow* TheWindow = nil;
	UIApplication* App = [UIApplication sharedApplication];
	NSArray* windows = [App windows];
	int i;
	for(i = 0; i < [windows count]; i++)
	{
		TheWindow = [windows objectAtIndex:i];
		if([TheWindow respondsToSelector:@selector(getCurrentTheme)])
		{
			break;
		}
	}
	
	if(i == [windows count])
	{
		NSLog(@"Couldn't find the app window, defaulting to keyWindow\n");
		TheWindow = [App keyWindow];
	}
	
	return TheWindow;
}

//************************************************************************************************************
// transitionIn - animates the view in place.
//************************************************************************************************************
- (void) transitionIn
{
	UIWindow* TheWindow = [self getAppWindow];
	
	[TheWindow addSubview: self];

	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.5];
	CGAffineTransform transformView	= CGAffineTransformMakeTranslation(297.0f, 0.0f);
	[self setTransform: transformView];
	[UIView commitAnimations];
}

@end

BOOL isCapable()
{
	return YES;
}

BOOL isEnabled()
{
	return YES;
}

void setState(BOOL Enable)
{
	NotesView* Notes = [[NotesView alloc] initWindow];
	[Notes transitionIn];
	[Notes release];
}

float getDelayTime()
{
	return 0.0f;
}


